/*
 * integrate1d.cpp
 *
 *  Created on: Feb 14, 2017
 *      Author: joe
 */

#include "integrate1d.h"
#include "hypercube_float.h"
#include "../main/simpleplot.h"

integrate1d::integrate1d(axis at) {
  _nt = at.n;
}

bool integrate1d::forward(bool add, my_vector *mod, my_vector *dat) {
  if(add && dat) dat->zero();

  hypercube_float *m = (hypercube_float*)mod;
  hypercube_float *d = (hypercube_float*)dat;

  if(m->get_axis(1).n != _nt && d->get_axis(1).n != _nt) {
    seperr("integrate1d: nt (%d) must be same as passed to constructor (%d)",m->get_axis(1).n,_nt);
  }

  d->vals[0] = m->vals[0];
  for(int it = 1; it < _nt; ++it) {
    d->vals[it] = d->vals[it-1] + m->vals[it];
  }

  return true;
}

bool integrate1d::adjoint(bool add, my_vector *mod, my_vector *dat) {
  if(add && mod) mod->zero();

  hypercube_float *m = (hypercube_float*)mod;
  hypercube_float *d = (hypercube_float*)dat;

  if(d->get_axis(1).n != _nt && d->get_axis(1).n != _nt) {
    seperr("integrate1d: nt (%d) must be same as passed to constructor (%d)",d->get_axis(1).n,_nt);
  }

  m->vals[_nt-1] = d->vals[_nt-1];
  for(int it = _nt-2; it >=0; --it) {
    m->vals[it] = m->vals[it+1] + d->vals[it];
  }

  return true;
}
