/*
 * pefmask.cpp
 *
 *  Created on: Mar 5, 2017
 *      Author: joe
 */
extern "C" {
#include "seplib.h"
}
#include "pefmask.h"
#include "hypercube_float.h"

bool pefmask::forward(bool add, my_vector *mod, my_vector *dat) {
  if(!add && dat) dat->zero();

  if(!dat->check_match(mod)) {
    seperr("pef_mask: model and data are not the same size.\n");
  }

  hypercube_float *m = (hypercube_float*)mod;
  hypercube_float *d = (hypercube_float*)dat;

  d->vals[0] = 0.0;
  for(int i = 1; i < m->get_axis(1).n; ++i) {
    d->vals[i] = m->vals[i];
  }

  return true;
}

bool pefmask::adjoint(bool add, my_vector *mod, my_vector *dat) {
  if(!add && mod) mod->zero();

  if(!dat->check_match(mod)) {
    seperr("pef_mask: model and data are not the same size.\n");
  }

  hypercube_float *m = (hypercube_float*)mod;
  hypercube_float *d = (hypercube_float*)dat;

  m->vals[0] = 0.0;
  for(int i = 1; i < d->get_axis(1).n; ++i) {
    m->vals[i] = d->vals[i];
  }

  return true;
}
