/*
 * waveletpad.cpp
 *
 *  Created on: Apr 8, 2017
 *      Author: joe
 */

#include "waveletpad.h"
#include "hypercube_float.h"

waveletpad::waveletpad(axis taxis) {
  _nt = taxis.n; _ot = taxis.o; _dt = taxis.d;
  _ntshift = 0;
}

waveletpad::waveletpad(axis taxis, float time) {
  _nt = taxis.n; _ot = taxis.o; _dt = taxis.d;
  if(time < 0) seperr("waveletpad: input time cannot be < 0\n");
  _ntshift = static_cast<int>(time/_dt);
}

void waveletpad::set_time(float time) {
  if(time < 0) seperr("shotpad: input time cannot be < 0.\n");
  _ntshift = static_cast<int>(time/_dt);
}

bool waveletpad::forward(bool add, my_vector *mod, my_vector *dat) {
  if(!add && dat) dat->zero();

  hypercube_float *m = (hypercube_float*)mod;
  hypercube_float *d = (hypercube_float*)dat;

  if(!m->get_axis(1).same_axis(axis(_nt,_ot,_dt)))
    seperr("waveletpad: model axis must be same as axis passed to constructor.\n");

  int ntp = d->get_axis(1).n;

  for(int it = 0; it < _nt; ++it) {
    if(it + _ntshift < ntp) {
      d->vals[it + _ntshift] += m->vals[it];
    }
  }

  return true;
}

bool waveletpad::adjoint(bool add, my_vector *mod, my_vector *dat) {

  return true;
}
