/**
 * Encodes the wavelet in time for
 * blended modeling
 * @author: Joseph Jennings
 * @version: 2017.04.06
 */
#ifndef _WAVELETPAD_H_
#define WAVELETPAD_H_

#include "my_operator.h"
#include "axis.h"

class waveletpad : public my_operator {
  public:
    waveletpad(){};
    waveletpad(axis taxis);
    waveletpad(axis taxis, float time);
    void set_time(float time);
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~waveletpad(){};

  private:
    int _nt, _ntshift;
    float _ot, _dt;
};

#endif /* WAVELETPAD_H_ */
