import sys 
import argparse
import re
import subprocess
import commands

parser = argparse.ArgumentParser()
parser.add_argument("dat")
parser.add_argument("pvec")
parser.add_argument("u")
parser.add_argument("fout")
parser.add_argument("-mi1",action="store",dest="min1")
parser.add_argument("-ma1",action="store",dest="max1")
parser.add_argument("-mi2",action="store",dest="min2")
parser.add_argument("-ma2",action="store",dest="max2")
parser.add_argument("-sc",action="store",dest="scale")
parser.add_argument("-dc",action="store",dest="dclip")
args = parser.parse_args()

dat  = args.dat
pvec = args.pvec
u    = args.u
fout = args.fout
if args.min1 == None:
  min1 = " "
else:
  min1 = "min1=%.15f"%(float(args.min1))
if args.max1 == None:
  max1 = " "
else:
  max1 = "max1=%.15f"%(float(args.max1))
# Get the hodogram axis 2 clipping
if args.min2 == None:
  min2 = " "
else:
  min2 = "min2=%.15f"%(float(args.min2))
if args.max2 == None:
  max2 = " "
else:
  max2 = "max2=%.15f"%(float(args.max2))
if args.dclip == None:
  dclip = " "
else:
  dclip = "clip=%f"%(float(args.dclip))
if args.scale == None:
  scale = " "
else:
  scale = "rscale=%f"%(float(args.scale))

cmd1=  '''
  Real < %s > r.H
  Imag < %s > i.H
  Cat axis=2 i.H r.H > wigdat.H
  Wiggle yreverse=y transp=y labelsz=4 titlesz=5\
    screenwd=5.0 pad=y zplot=0.2 title=' Y                 X' wantaxis2=n %s\
    poly=y crowd=0.7 label1='Time (s)' labelrot=n labelfat=2 titlefat=2 labelsz=5 \
    yinch=5.0 xinch=2.5 label2=' ' out=./Fig/dat.v < wigdat.H > /dev/null
    vppen ./Fig/dat.v xshift=-1.0 > ./Fig/shfdat.v
'''%(dat,dat,dclip)

cmd2= '''
  Graph %s %s %s %s title=' ' \
    label1='X' label2='Y' xinch=5.0 yinch=5.0 labelsz=5 \
    labelfat=2 titlefat=2 out=./Fig/sincos.v < %s > /dev/null
'''%(min1,max1,min2,max2,dat)

cmd3= '''
  Real < %s > ru.H
  Imag < %s > iu.H
  Cat axis=2 iu.H ru.H > wigu.H
  Wiggle yreverse=y transp=y labelsz=5 \
    screenwd=5.0 pad=y zplot=0.2 title='U' titlesz=5 \
    poly=y crowd=0.7 label1='Time (s)' labelrot=n \
    yinch=5.0 xinch=2.5 label2=' ' out=./Fig/tmpu.v wantaxis2=n \
    labelfat=2 titlefat=2 < wigu.H > /dev/null
  vppen ./Fig/tmpu.v xshift=3.0 > ./Fig/uplt.v
'''%(u,u)

# Get maximum absolute value of hodogram
cmd4= '''
  Scale %s < %s > npvecs.H
  Window n1=2 j1=1 f1=0 < npvecs.H > v1.H
  Window n1=2 j1=2 f1=0 < npvecs.H > v2.H
  Graph %s %s %s %s title=' ' label1=' ' \
    label2=' ' out=./Fig/v1.v xinch=5.0 yinch=5.0 \
    labelsz=5 labelfat=2 titlefat=2 plotfat=4 < v1.H >  /dev/null
  Graph %s %s %s %s title='SV\^T' titlesz=5 label1=' ' \
    label2=' ' plotcol=4 xinch=5.0 yinch=5.0 labelsz=5 labelfat=2 \
    plotfat=4 out=./Fig/v2.v < v2.H > /dev/null
  vppen style=n xshift=2.5 erase=o ./Fig/v1.v ./Fig/v2.v ./Fig/sincos.v > ./Fig/pvovr.v
'''%(scale,pvec,min1,max1,min2,max2,min1,max1,min2,max2)

comb= '''
vppen ./Fig/shfdat.v ./Fig/uplt.v ./Fig/pvovr.v erase=o style=n > %s
'''%(fout)

sp = subprocess.check_call(cmd1,shell=True)
sp = subprocess.check_call(cmd2,shell=True)
sp = subprocess.check_call(cmd3,shell=True)
sp = subprocess.check_call(cmd4,shell=True)
sp = subprocess.check_call(comb,shell=True)
print cmd2
print cmd4

# Clean up
rm= '''
Rm npvecs.H r.H i.H ru.H iu.H wigu.H wigdat.H v1.H v2.H
rm ./Fig/v1.v ./Fig/v2.v ./Fig/pvovr.v ./Fig/tmpu.v ./Fig/uplt.v \
    ./Fig/dat.v ./Fig/sincos.v
'''
#sp = subprocess.Popen(rm,shell=True)
