/**
 * Tests the 1D integration operator
 * @author: Joseph Jennings
 * @version: 2017.02.14
 */

#include "sep_params.h"
#include "../main/integrate1d.h"

int main(int argc, char **argv) {

  sep_params pars = sep_params(argc,argv);

  sregf fin = sregf("in");

  hypercube_float *sig = new hypercube_float(fin.get_axes(),true);
  hypercube_float *sum = new hypercube_float(fin.get_axes(),true);

  fin.read_all("in",sig);

  integrate1d iop = integrate1d(sig->get_axis(1));

  iop.forward(false,sig,sum);

  sregf fout = sregf(sum->get_axes());

  fout.write_description("out");
  fout.write_all("out",sum);

  delete sig;
}
