#include "my_vector.h"

#include "generic_norm.h"
#include<math.h>
#include <iostream>    
#define PREC 1e-8

generic_norm::generic_norm(int ps_iter,int nreduce ){ 
  zero_it();
  niter=ps_iter;
  n_reduce=nreduce;
  rt=0;
}
void generic_norm::zero_it(){
 s=0; ss=0; c0=0; c1=0; c2=0;

}
void generic_norm::delete_norm(){

        
        if(s!=0) delete s;
        if(ss!=0) delete ss;
        if(c0!=0) delete c0;
        if(c1!=0) delete c1;
        if(c2!=0) delete c2;
        if(rt!=0) delete rt;
        rt=0;
        s=0;
        ss=0;
        c0=0;
        c1=0;
        c2=0;
        }
void generic_norm::alloc_step(my_vector *mod, norm_vector *dat){


  s=mod->clone_vec();
  ss=dat->clone_vec();
  c0=dat->clone_vec();
  c1=dat->clone_vec();
  c2=dat->clone_vec();
  tmp_ss=(norm_vector*)dat->clone_vec();
  tmp_rr=(norm_vector*)dat->clone_vec();
  rt=(norm_vector*) dat->clone_vec();
  forget_it();
 

}
bool generic_norm::solve_alfa_beta(bool forget, my_vector *gg,my_vector *ss,my_vector *c1, my_vector *c2, 
  double *alfa, double *beta ){

  if(forget){
    *beta=0.0;
    my_vector *gdg=gg->clone_vec();
    gdg->mult(gg);
    double c2dgg=gdg->dot(c2);

    delete gdg;
  //  c1->info("C1");
  //  c2->info("C2");
   // gg->info("gg");
    if(fabs(c2dgg)<PREC) {
      fprintf(stderr,"c2dgg(%g) <0.\n",c2dgg);
      return false;
    }

    *alfa=-c1->dot(gg)/c2dgg;


  }
  else{
    double c1dg=-gg->dot(c1);  //c1dg = -C'*G
    double c1ds=-ss->dot(c1);  //c1ds = -C'*S

    my_vector *gdg=gg->clone_vec();
    my_vector *sds=ss->clone_vec();
    my_vector *gds=ss->clone_vec();
    
    gdg->mult(gg); //search plane by solving 2-by-2
    sds->mult(ss); //C"*G . (G*alfa + S*beta) = -C'*G
    gds->mult(gg); //C"*S . (G*alfa + S*beta) = -C'*S
    
    double c2dgg=c2->dot(gdg);//c2dgg = C"*G*G
    double c2dss=c2->dot(sds);//c2dss = C"*S*S
    double c2dgs=c2->dot(gds);//c2dgs = C"*G*S

   delete gdg; delete sds; delete gds;
   if(fabs(c2dgg)< PREC || fabs(c2dss) < PREC){
     fprintf(stderr,"TROUBLE WITH c2dgg(%g) c2dss(%g) \n",c2dgg,c2dss);
     return false;
   }
   double sin0_2=1-(gg->dot(ss)/gg->dot(gg))*(gg->dot(ss)/ss->dot(ss));
   if(sin0_2<1e-3){ 
     fprintf(stderr,"sin0_2 is small \n");
     return false;
   }
   double determ=1-(c2dgs/c2dgg)*(c2dgs/c2dss);
   determ = c2dgg * c2dss * determ;
   
   if(determ<PREC){
     fprintf(stderr,"Determinate is small \n");
     return false;
   }
 

     *alfa = ( c2dss * c1dg - c2dgs * c1ds ) / determ;
     *beta = (-c2dgs * c1dg + c2dgg * c1ds ) / determ;
 

  }
  return true;
   


}
int generic_norm::evaluate_pen_func(double prev_sum_norm, double sum_norm, my_vector *r, 
  double *c_alfa_out, double *c_beta_out, double alfa, double beta){

  int ret;
  double rat=(prev_sum_norm-sum_norm)/prev_sum_norm;
//  fprintf(stderr,"RATIO IS %g %g %g %g %g \n",prev_sum_norm,sum_norm,rat,alfa,beta);
  
  if(rat >PREC || fabs(sum_norm)<PREC){
    prev_sum_norm=sum_norm;
    *c_alfa_out+=alfa;
    *c_beta_out+=beta;
    if(rat>.99) ret=2;
    else ret =0;
  }
  else if(rat >=-PREC) {
  fprintf(stderr,"RATIO IS %g %g %g %g %g \n",prev_sum_norm,sum_norm,rat,alfa,beta);
    ret=1;
  
  }
  else ret=-1;
  return ret;
}
bool generic_norm::step_it(int ith,my_vector *m, my_vector *g, norm_vector *rr, norm_vector *gg,
  double *vv){

  double prev_sum_norm=0.0,sum_norm;
  tmp_rr->scale_add(0.,rr,1.);


  tmp_ss->scale_add(0.,ss,1.);

  double c_alfa=0,c_beta=0.,alfa=0.,beta=0.;

/*

   cgstep_ps = 2  ! preset the return value of this function

    tmp_rr = rr

    
    avg_rm = 0; avg_rd = 0;
*/


  bool quit=false;
  int iter=0;
  bool exit_loop=false;
  time_norm.start();
  norm_vector *rt=(norm_vector*)tmp_rr->return_norm_param();
 time_norm.stop();
  while(iter< niter && !exit_loop){
  time_d.start();
    tmp_rr->calc_norm_deriv(rt,c0,c1,c2);
    time_d.stop();
    //R_tmp=sum(c0);  
    if(iter==0){
      prev_sum_norm=c0->sum() ;
      sum_norm=prev_sum_norm;
   
    }
    else{
   //   fprintf(stderr,"ABOUT TO EVALUATE \n");
       sum_norm=c0->sum();
        //    fprintf(stderr,"CHECK NORM %g %g \n",sum_norm,prev_sum_norm);

time_e.start();
      int stat=evaluate_pen_func(prev_sum_norm,sum_norm,tmp_rr,&c_alfa,&c_beta,alfa,beta);
fprintf(stderr,"EVALUTE iter=%d old=%g new=%g stat=%d\n",iter,prev_sum_norm,sum_norm,stat);
    time_e.stop();
    prev_sum_norm=sum_norm;
     
      if(stat==1){
        if(iter==1){ 
          fprintf(stderr," stat=1 in evaluate penalty function \n");
          return false;
         }
        exit_loop=true;
      }
      if(stat==-1){ //Overshoot
        bool found=false; 
        int j=1;
        while(!found && j < n_reduce){
          fprintf(stderr,"REDUCING PENALTY FUNCTION %d %d %g %g %g\n",j,iter,alfa,beta,sum_norm);
          j+=1;
          alfa*=.5; beta*=.5;
       //  fprintf(stderr,"REDUCING ALPHA %g %g \n",alfa,beta);
       time_u.start();
          tmp_ss->scale_add(0.,gg,alfa); tmp_ss->scale_add(1.,ss,beta);
          tmp_rr->scale_add(0.,rr,1.); tmp_rr->scale_add(1.,gg,c_alfa);
          tmp_rr->scale_add(1.,tmp_ss,1.);tmp_rr->scale_add(1.,ss,c_beta);
          tmp_rr->calc_norm_deriv(rt,c0,c1,c2);
          sum_norm=c0->sum();
          time_u.stop();
          int stat2=evaluate_pen_func(prev_sum_norm,sum_norm,tmp_rr,&c_alfa,&c_beta,alfa,beta);
          if(stat2>=0){
        //    fprintf(stderr,"I AM HAPPY  THe norm is %g prev=%g \n",sum_norm,prev_sum_norm);
            found=true;
          }
        }
        if(!found) {
          if(iter<2){
            fprintf(stderr,"couldn't reduce norm \n");
            return false;

          }
          exit_loop=true;
        }
      }
      if(stat==2) exit_loop=true;
      
    }

//fprintf(stderr,"ABOUT TO DO ALFA BETA \n");
    if(!this->solve_alfa_beta(forget,gg,ss,c1,c2,&alfa,&beta)){
      fprintf(stderr,"WARNING: Trouble finding alfa and beta \n");
       return false;
    }
//  fprintf(stderr,"ALPHA=%g BETA=%g  \n",alfa,beta);
time_u_2.start();
    tmp_ss->scale_add(0.,gg,alfa);
    tmp_ss->scale_add(1.,ss,beta);
    tmp_rr->scale_add(1.,tmp_ss,1.);
    time_u_2.stop();
//      fprintf(stderr,"THE NORM %d (%g) alpha=%g beta=%g c_alpha=%g beta=%g \n",iter,sum_norm,
    // alfa,beta,c_alfa,c_beta);
    iter+=1;
  }

 //fprintf(stderr,"%d C_ALFA is %g  c_bveta %g norm=%g\n",ith,c_alfa,c_beta,sum_norm);
  if(fabs(c_alfa) > 1e-25){

    if(forget){
       s->scale_add(0.,g,c_alfa);
       ss->scale_add(0.,gg,c_alfa);
       forget=false;
     }
     else{
      s->scale_add(c_beta,g,c_alfa);
      ss->scale_add(c_beta,gg,c_alfa);
     }
  //   s->info("MODEL UPDATE IS",3);
     m->scale_add(1.,s,1.);
     rr->scale_add(1.,ss,1.);
   }
   else{
     fprintf(stderr,"c_afla is to small\n");
     return false;
   }
  // c0->info("rr.H",2);
  *vv=rr->dot(rr);
  delete rt;
 // rr->info("rr.H",2);
  // m->info("rr.H",1);
   return true;
  }
