#ifndef generic_norm_H
#define generic_norm_H 1
#include<my_vector.h>
#include<step.h>
#include<stdio.h>
#include <norm.h>
#include "hypercube_float.h"
#include "timer.h"
class generic_norm: public step{

  public:
    generic_norm(){zero_it(); }
    generic_norm(int ps_iter, int nreduce=30);
    virtual bool step_it(int iter, my_vector *x, my_vector *g, norm_vector *rr, norm_vector *gg, 
    double *sc);
    virtual void alloc_step(my_vector *mod,norm_vector *dat);
    int evaluate_pen_func(double prev_sum_norm, double sum_norm, my_vector *r, 
      double *c_alfa_out, double *c_beta_out, double alfa, double beta);
    bool solve_alfa_beta(bool forget, my_vector *gg,my_vector *ss,my_vector *c1,
    my_vector *c2, 
  double *alfa, double *beta );
  //  virtual void scale_residual(norm_vector *in, norm_vector *out);
    void forget_it(){ 
      forget=true;
      s->zero(); ss->zero();  
      small=1e-20;
    }
    void zero_it();
   void delete_norm();
    ~generic_norm(){

     }
         timer time_u_2,time_u,time_norm,time_e,time_d;

  private:
    hypercube_float *error_cg;
    my_vector *s, *ss,*c0,*c1,*c2;
    norm_vector *tmp_ss,*tmp_rr,*rt;
    bool forget;
    double small;
    int niter,n_reduce;
  };


#endif
