#include "hybrid_norm.h"
#include "assert.h"
#include "hypercube_float.h"
#include "seplib.h"

my_vector *hybrid_norm::return_param_vec(my_vector *vec){
  
  return vec->fill_percentile();

  
  }

void hybrid_norm::norm_scale(my_vector *vin, my_vector *vout){ 
 my_vector *rt=vin->fill_percentile();
 my_vector *term=calc_term(vin,rt);
 calc_c1(vout,term,rt,vin);

// rt->info("rt",1);
 //term->info("term",1); 
 //rt->info("rt",1);
 delete rt; delete term;
 

}
void hybrid_norm::calc_c1(my_vector *c1, my_vector *term, my_vector *rt, my_vector *res){

  c1->scale_add(0.,term,1.); // c1=term;
  c1->mult(rt); //c1=term*rt
  c1->invert(); //c1=1./(term*rt)
  
  if(rite){
    hypercube_float *d1=(hypercube_float*) c1;
    srite("vec.H",d1->vals,(int)d1->get_n123()*4);
    fprintf(stderr,"RITING \n");
  }
  c1->mult(res); //c1=res/(term*rt)
 
}
void hybrid_norm::calc_c0(my_vector *c0, my_vector *term, my_vector *rt){
  c0->set_val(-1.);
  c0->add(term);  //term-1
  c0->mult(rt);//c0->mult(rt);  //rt*rt*(term-1);
}
void hybrid_norm::calc_c2(my_vector *c2, my_vector *rt, my_vector *term){
 
  my_vector *tt=rt->clone_vec();
  tt->invert(); //tt=1./rt
  c2->scale_add(0.,term,1.);
  c2->power(-3.); //c2=1./term^3
  c2->mult(tt); //c2=1./(term^3*rt)
  delete tt;
  

}
my_vector *hybrid_norm::calc_term(my_vector *res, my_vector *rt){
  
  my_vector *term=res->clone_vec();
  my_vector *tt=rt->clone_vec();
  term->mult(term); //rr*rr
  tt->mult(tt);  //rt**2
  tt->invert(); //1./rt**2
 // term->info("mid term",3);
 // tt->info("rt sq",3);
  my_vector *x=term->clone_vec(); x->set_val(1.);
  term->mult(tt); ///rr*rr/rt/rt
  delete tt;
  term->add(x) ;//rr*rr/rt/rt+1
  delete x;
  term->power(0.5); //sqrt(1+rr*rr/rt/rt);
   return term;
}
void hybrid_norm::calc_coefs(my_vector *res, my_vector *rt,my_vector *c0, my_vector *c1,my_vector *c2){ 

  my_vector *term=calc_term(res,rt);
  calc_c0(c0,term,rt);
  calc_c1(c1,term,rt,res);
  calc_c2(c2,rt,term);
//   res->info("res",2);
//rt->info("rt",2);
//term->info("term",3);
 // c0->info("c0",3);
//  c1->info("c1",3);
//  c2->info("c2",3);
 // assert(1==2);
  delete term;

}
