#include "hypercube_complex.h"
#include <cstring>

//hypercube_complex::hypercube_complex(std::vector<axis> axes){
//
//  this->init_nd(axes);
//
//}

hypercube_complex::hypercube_complex(std::vector<axis> axes,bool alloc){
  this->init_nd(axes);
  if(alloc) {
    this->vals=new std::complex<float>[this->get_n123()];
  }
  else this->vals=0;
}

hypercube_complex::hypercube_complex(std::vector<axis> axes, std::complex<float> *vals){

  this->init_nd(axes);
  this->vals = new std::complex<float>[this->get_n123()];
  this->set(vals);

}

hypercube_complex::hypercube_complex(std::vector<axis> axes, std::complex<double> *vals){

  this->init_nd(axes);
  this->vals = new std::complex<float>[this->get_n123()];
  this->set(vals);

}

void hypercube_complex::set(std::complex<float> *array){

  memcpy((void*)this->vals, (const void*) array,
      sizeof(std::complex<float>) * this->get_n123());

}

void hypercube_complex::set(std::complex<double> *array){

  for(int i = 0; i < this->get_n123(); ++i)
    this->vals[i] = static_cast<std::complex<float>>(array[i]);
}
