/**
 * Directional derivative used in
 * an absorbing boundary for FD
 * wave propagation. Basically
 * a port from Ali's code from
 * SEP 149
 * @author: Joseph Jennings
 * @version: 2016.11.27
 */
#ifndef BCDER_H_
#define BCDER_H_

#include <vector>
#include "my_operator.h"
#include "axis.h"

class bcder : my_operator {
  public:
    bcder(){};
    bcder(std::vector<axis> uaxis, std::vector<int> nbs, int order);
    bool forward(bool add, my_vector *model, my_vector *data);
    bool adjoint(bool add, my_vector *model, my_vector *data);
    ~bcder(){};

  private:
    int _nz, _nx;
    int _bz1, _bz2, _bx1, _bx2;
    int _shift;
};

#endif /* BCDER_H_ */
