/**
 * Born scattering and imaging
 * condition operator
 * @author: Joseph Jennings
 * @version: 2016.12.28
 */
#ifndef BSCAT_H_
#define BSCAT_H_

#include "my_operator.h"
#include "hypercube_float.h"

class bscat : public my_operator {

  public:
    bscat(){};
    bscat(hypercube_float *u0);
    bool forward(bool add, my_vector *model, my_vector *data);
    bool adjoint(bool add, my_vector *model, my_vector *data);
    ~bscat(){
      delete _u0;
    };

  private:
    hypercube_float *_u0;
    int _nz, _nx, _nt;

};


#endif /* BSCAT_H_ */
