/**
 * Generic class for the it-1
 * finite difference coefficient
 * @author: Joseph Jennings
 * @version: 2016.11.17
 */
#ifndef FDCOEF_H_
#define FDCOEF_H_

#include "laplacian.h"
#include "hypercube_float.h"

class fdcoef : public my_operator {
  public:
    fdcoef(){};
    fdcoef(std::vector<axis> uaxis, laplacian* lapop, hypercube_float *v2dt2,
        hypercube_float *wgt, hypercube_float *vwt, std::vector<int> nbs);
    fdcoef(std::vector<axis> uaxis, laplacian* lapop, hypercube_float *v2dt2);
    virtual ~fdcoef(){};

    int _nx, _nz;
    laplacian *_lapop;
    hypercube_float *_v2dt2, *_lap;
    hypercube_float *_wgt = nullptr;
    hypercube_float *_vwt = nullptr;

};

#endif /* FDCOEF_H_ */
