/**
 * it-1 finite difference coefficient
 * with absorbing boundaries
 * @author: Joseph Jennings
 * @version: 2016.11.27
 */

#ifndef FDCOEFB_H_
#define FDCOEFB_H_

#include "fdcoef.h"
#include "bcder.h"

class fdcoefb : public fdcoef {
  public:
    fdcoefb(){};
    fdcoefb(std::vector<axis> azx, laplacian* lapop, hypercube_float *v2dt2,
        hypercube_float *w, hypercube_float *vwt, std::vector<int> nbs);
    bool forward(bool add, my_vector *model, my_vector *data);
    bool adjoint(bool add, my_vector *model, my_vector *data);
    ~fdcoefb(){};

  private:
    bcder _bdop;
    hypercube_float *_bder;

};

#endif /* FDCOEFB_H_ */
