/**
 * Computes the spatial gradient of a
 * 3D wavefield
 * @author: Joseph Jennings
 * @version: 2017.01.10
 */
#ifndef IGRAD3_H_
#define IGRAD3_H_

#include <vector>
#include "my_operator.h"
#include "axis.h"

class igrad3 : my_operator {
  public:
    igrad3(){};
    igrad3(std::vector<axis> uaxes);
    bool forward(bool add, my_vector *model, my_vector *data);
    bool adjoint(bool add, my_vector *model, my_vector *data);
    ~igrad3(){};

  private:
    int _nz, _nx, _ny, _nt;
    float _idz, _idx, _idy;
};

#endif /* IGRAD3_H_ */
