/**
 * Abstract laplacian operator
 * Each laplacian operator
 * must have a specific stencil order
 * @author: Joseph Jennings
 * @version: 2017.01.14
 *
 */
#ifndef LAPLACIAN_H_
#define LAPLACIAN_H_

#include "my_operator.h"
#include "my_vector.h"
#include "axis.h"
#include <vector>

class laplacian : public my_operator {

  public:
    laplacian(){};
    laplacian(std::vector<axis> uaxis);
    virtual int get_myorder() {return _myorder;};
    virtual std::vector<double> get_mycoefs() {return _coefs;};
    int _myorder;
    int _nx, _nz;
    float _idx2, _idz2;
    std::vector<double> _coefs;
    virtual ~laplacian(){};
};

#endif /* LAPLACIAN_H_ */
