/*
 * laplacian10thispc.cpp
 *
 *  Created on: Apr 5, 2017
 *      Author: joe
 */

#include "laplacian10thispc.h"
#include "hypercube_float.h"

laplacian10thispc::laplacian10thispc(std::vector<axis> uaxes) {
  if(uaxes.size() < 2) seperr("Must apply laplacian to vector with dim > 1.\n");
  _idz2 = 1/(uaxes[0].d * uaxes[0].d); _idx2 = 1/(uaxes[1].d * uaxes[1].d);
  _nz = uaxes[0].n; _nx = uaxes[1].n;
  _myorder = 10; //Hardcoding as we do not have the coefs
}

bool laplacian10thispc::forward(bool add, my_vector *mod, my_vector *dat) {
  if(!add && dat) dat->zero();

  hypercube_float* m = (hypercube_float*)mod;
  hypercube_float* d = (hypercube_float*)dat;
  laplacianFWDISPC(_nx,_nz,_idx2,_idz2,m->vals,d->vals);

  return true;
}

bool laplacian10thispc::adjoint(bool add, my_vector *mod, my_vector *dat) {
  if(!add && mod) mod->zero();

  hypercube_float* m = (hypercube_float*)mod;
  hypercube_float* d = (hypercube_float*)dat;

  laplacianADJISPC(_nx,_nz,_idx2,_idz2,m->vals,d->vals);

  return true;
}
