/**
 * Wrapper for 10th-order Laplacian
 * in ISPC
 * @author: Joseph Jennings
 * @version: 2017.04.05
 */
#ifndef LAPLACIAN10THISPC_H_
#define LAPLACIAN10THISPC_H_

#include "laplacian.h"
extern "C" {
#include "laplacianFWDISPC.h"
#include "laplacianADJISPC.h"
}

class laplacian10thispc : public laplacian {
  public:
    laplacian10thispc(){};
    laplacian10thispc(std::vector<axis> uaxes);
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~laplacian10thispc(){};
};

#endif /* LAPLACIAN10THISPC_H_ */
