/**
 * Abstract 3D laplacian operator.
 * Each laplacian must have a specific
 * order.
 * @author: Joseph Jennings
 * @version: 2017.01.14
 */
#ifndef LAPLACIAN3D_H_
#define LAPLACIAN3D_H_

#include "my_operator.h"
#include "my_vector.h"
#include "axis.h"
#include <vector>

class laplacian3d : public my_operator {

  public:
    laplacian3d(){};
    laplacian3d(std::vector<axis> uaxis);
    virtual int get_myorder() {return _myorder;};
    virtual std::vector<double> get_mycoefs() {return _coefs;};
    int _myorder;
    int _nz, _nx, _ny;
    float _idz2, _idx2, _idy2;
    std::vector<double> _coefs;
};

#endif /* LAPLACIAN3D_H_ */
