/**
 * 3D 10th order laplacian stencil
 * inherited from laplacian
 * @author: Joseph Jennings
 * @version: 2017.01.14
 */
#ifndef LAPLACIAN3D10TH_H_
#define LAPLACIAN3D10TH_H_

#include "laplacian3d.h"

class laplacian3d10th : public laplacian3d {
  public:
    laplacian3d10th();
    laplacian3d10th(std::vector<axis> uaxis);
    virtual bool forward(bool add, my_vector* model, my_vector* data);
    virtual bool adjoint(bool add, my_vector* model, my_vector* data);
    ~laplacian3d10th();

  private:
    /* Taken from Ali Almomin's 'Accurate Implementation of Wave-equation operators' - SEP 149 -> laplace.f90 */
    std::vector<double>_coefs10 = {-2.9272222519,1.6666666665,-0.2380952381,0.0396825397,-0.00496031745,0.0003174603};
};

#endif /* LAPLACIAN3D10TH_H_ */
