/**
 * 3D fourth order laplacian stencil
 * inherited from laplacian3D
 * @author: Joseph Jennings
 * @version: 2017.01.14
 */
#ifndef LAPLACIAN3D4TH_H_
#define LAPLACIAN3D4TH_H_

#include "laplacian3d.h"

class laplacian3d4th : public laplacian3d {

  public:
    laplacian3d4th(){};
    laplacian3d4th(std::vector<axis> uaxis);
    virtual bool forward(bool add, my_vector* model, my_vector* data);
    virtual bool adjoint(bool add, my_vector* model, my_vector* data);
    ~laplacian3d4th(){}

  private:
    std::vector<double>_coefs4 = {-2.500000000,1.3333333333,-0.08333333333};
};

#endif /* LAPLACIAN3D4TH_H_ */
