/**
 * Fourth order laplacian stencil
 * inherited from laplacian
 * @author: Joseph Jennings
 * @version: 2017.01.14
 */
#ifndef LAPLACIAN4TH_H_
#define LAPLACIAN4TH_H_

#include "laplacian.h"

class laplacian4th : public laplacian {

  public:
    laplacian4th(){};
    laplacian4th(std::vector<axis> uaxis);
    virtual bool forward(bool add, my_vector* model, my_vector* data);
    virtual bool adjoint(bool add, my_vector* model, my_vector* data);
    ~laplacian4th(){};

  private:
    std::vector<double>_coefs4 = {-2.500000000,1.3333333333,-0.08333333333};
};

#endif /* LAPLACIAN4TH_H_ */
