/**
 * Source scale operator for scaling the
 * source wavelet before wave propagation
 * @author: Joseph Jennings
 * @version: 2016.11.24
 */
#ifndef SOURCESCALE_H_
#define SOURCESCALE_H_

#include "my_operator.h"
#include "hypercube_float.h"

class sourcescale : public my_operator {
  public:
    sourcescale(){};
    sourcescale(float dtu, hypercube_float *vel);
    sourcescale(float dtu, hypercube_float *vel, hypercube_float *w);
    virtual bool forward(bool add, my_vector *mod, my_vector *dat);
    virtual bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~sourcescale(){
      delete _v2dtu2;
      if(_w) delete _w;
    };

  private:
    hypercube_float *_v2dtu2;
    hypercube_float *_w;
};

#endif /* SOURCESCALE_H_ */
