/**
 * Source scale operator for scaling the
 * source wavelet before 3D wave propagation
 * @author: Joseph Jennings
 * @version: 2017.01.07
 */
#ifndef SOURCESCALE3D_H_
#define SOURCESCALE3D_H_

#include "my_operator.h"
#include "hypercube_float.h"

class sourcescale3d : public my_operator {
  public:
    sourcescale3d(){};
    sourcescale3d(float dtu, hypercube_float *vel);
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~sourcescale3d(){
      delete _v2dtu2;
    };

  private:
    hypercube_float *_v2dtu2;
};

#endif /* SOURCESCALE3D_H_ */
