/**
 * Stopwatch class for measuring
 * execution time in code
 * @author: Joseph Jennings
 * @version: 2016.01.02
 */
#ifndef STOPWATCH_H_
#define STOPWATCH_H_

class stopwatch {
  public:
    stopwatch(){};
    /**
     * Starts this stopwatch. If the stopwatch is running,
     * does nothing.
     */
    void start();
    /**
     * Stops this stopwatch. If the stopwatch is not running,
     * does nothing.
     */
    void stop();
    /**
     * Stops this stopwatch and resets the time to zero.
     */
    void reset();
    /**
     * Resets and starts this stopwatch.
     */
    void restart();
    /**
     * Returns the stopwatch time, in seconds.
     * Does not start or stop.
     * @return the time, in seconds.
     */
    double time();
    ~stopwatch(){};
  private:
    bool _running;
    long _start;
    long _time;
};


#endif /* STOPWATCH_H_ */
