/**
 * A taper boundary condition for
 * absorbing boundary wave propagation
 * @author: Yinbin Ma
 *          with minor modifications by Joseph Jennings
 * @version: 2017.01.04
 */
#ifndef TAPERCOS_H_
#define TAPERCOS_H_

#include <vector>
#include "axis.h"
#include "hypercube_float.h"

class tapercos {
  public:
    tapercos(){};
    tapercos(std::vector<axis> azx, int bz, int bx, int ord, float alpha);
    void apply(hypercube_float *cur, hypercube_float *nex);
    hypercube_float* get_taper();
    ~tapercos(){ delete _tap; };
  private:
    hypercube_float *_tap;
    int _nz, _nx, _bz, _bx, _shift, _nshift;
    float _alpha;
    void build_taper(hypercube_float *in);
};

#endif /* TAPERCOS_H_ */
