/**
 * Zero pad operator for preparing
 * input source for wave propagation
 * @author: Joseph Jennings
 * @version: 2017.01.07
 */
#ifndef ZEROPAD_H_
#define ZEROPAD_H_

#include "my_operator.h"
#include "my_vector.h"

class zeropad : public my_operator {

  public:
    zeropad(){} //Default constructor
    zeropad(int xloc, int zloc);
    zeropad(int xloc, int zloc, float val);
    virtual bool forward(bool add, my_vector *src, my_vector *psrc);
    virtual bool adjoint(bool add, my_vector *src, my_vector *psrc);

  private:
    int _xloc, _zloc;
    float _val = 0;

};

#endif /* ZEROPAD_H_ */
