/**
 * 3D zeropad operator for preparing
 * input source for 3D wave propagation
 * @author: Joseph Jennings
 * @version: 2017.01.07
 */
#ifndef ZEROPAD3D_H_
#define ZEROPAD3D_H_

#include "my_operator.h"

class zeropad3d : public my_operator {
  public:
    zeropad3d(){};
    zeropad3d(int zloc, int xloc, int yloc);
    zeropad3d(int zloc, int xloc, int yloc, float val);
    bool forward(bool add, my_vector *model, my_vector *data);
    bool adjoint(bool add, my_vector *model, my_vector *data);
    ~zeropad3d(){};

  private:
    int _xloc, _zloc, _yloc;
    float _val = 0.0;
};

#endif /* ZEROPAD3D_H_ */
