/**
 * A Zero Pad operator for padding
 * and truncating 3D cubes
 * @author: Joseph Jennings
 * @version: 2017.01.07
 */
#ifndef ZEROPADCUB_H_
#define ZEROPADCUB_H_

#include "my_operator.h"

class zeropadcub : public my_operator {
  public:
    zeropadcub(){};
    zeropadcub(int zloc, int xloc, int yloc);
    zeropadcub(int zloc, int xloc, int yloc, float fill);
    bool forward(bool add, my_vector *model, my_vector *data);
    bool adjoint(bool add, my_vector *model, my_vector *data);
    ~zeropadcub(){};
  private:
    int _zloc, _xloc, _yloc;
    float _fill = 0.0;
};

#endif /* ZEROPADCUB_H_ */
