/**
 * A Zero Pad operator for padding
 * and truncating 2D images
 * @author: Joseph Jennings
 * @version 2016.11.26
 */
#ifndef ZEROPADIMG_H_
#define ZEROPADIMG_H_

#include "my_operator.h"
#include "my_vector.h"

class zeropadimg : public my_operator {
  public:
    zeropadimg(){};
    zeropadimg(int zloc, int xloc, float fill);
    virtual bool forward(bool add ,my_vector *model, my_vector *data);
    virtual bool adjoint(bool add ,my_vector *model, my_vector *data);
    ~zeropadimg(){};

  private:
    int _zloc, _xloc;
    float _fill;
};

#endif /* ZEROPADIMG_H_ */
