/**
 * A Zero Pad operator for wavefields
 * Pads or truncates in x and z.
 * @author: Joseph Jennings
 * @version: 2016.12.13
 */
#ifndef ZEROPADWFLD_H_
#define ZEROPADWFLD_H_

#include "my_operator.h"

class zeropadwfld : public my_operator {
  public:
    zeropadwfld(){}; //Default constructor
    zeropadwfld(int zloc, int xloc);
    zeropadwfld(int zloc, int xloc, float fill);
    virtual bool forward(bool add, my_vector *model, my_vector *dat);
    virtual bool adjoint(bool add, my_vector *model, my_vector *dat);
    ~zeropadwfld(){};

  private:
    int _zloc, _xloc;
    float _fill;
};

#endif /* ZEROPADWFLD_H_ */
