#include <stdio.h>
#include <stdlib.h>
#include "axis.h"
#include "sep_params.h"
#include "sreg.h"
#include "sregf.h"
#include "../main/gnuplot-iostream.h"

using namespace std;

int main(int argc, char **argv) {

  /* Initialize IO */
  sep_params pars = sep_params(argc,argv);

  /* Read in a 1D file */
  sregf datin = sregf("in");

  hypercube_float *dat1d = new hypercube_float(datin.get_axes(), true);
  datin.read_all("in", dat1d);

  std::vector<std::pair<float, float> > spiketest;
  for(int k = 0; k < dat1d->get_n123(); ++k) {
    fprintf(stderr, "k=%d val=%f\n", k, dat1d->vals[k]);
    spiketest.push_back(make_pair(static_cast<float>(k*dat1d->get_axis(1).d),static_cast<float>(dat1d->vals[k])));
    fprintf(stderr, "pair=%f %f\n", spiketest[k].first, spiketest[k].second);
  }

  Gnuplot gp;

  std::vector<std::pair<double, double> > xy_pts_A;
  for(double x=-2; x<2; x+=0.01) {
    double y = x*x*x;
    xy_pts_A.push_back(std::make_pair(x, y));
  }

  std::vector<std::pair<double, double> > xy_pts_B;
  for(double alpha=0; alpha<1; alpha+=1.0/24.0) {
    double theta = alpha*2.0*3.14159;
    xy_pts_B.push_back(std::make_pair(cos(theta), sin(theta)));
  }

  //gp << "set xrange [-2:2]\nset yrange [-2:2]\n";
  //gp << "plot '-' with lines title 'cubic', '-' with points title 'circle'\n";
  //gp.send1d(xy_pts_A);
  //gp.send1d(xy_pts_B);

  gp << "set xrange [0:0.04]\nset yrange [0:1]\n";
  gp << "plot '-' with lines title 'spike'\n";
  gp.send1d(spiketest);

  datin.write_description("out");
  datin.write_all("out", dat1d);

  return 0;
}
