/**
 * A simple program to test the igrad3
 * operator.
 * @author: Joseph Jennings
 * @version: 2017.01.10
 */

#include "sep_params.h"
#include "../main/igrad3.h"

int main(int argc, char **argv) {

  sep_params pars = sep_params(argc, argv);
  int adj = pars.get_int("adj",0);

  sregf fin = sregf("in");

  if(adj) {
    /* Build hypercubes */
    hypercube_float *trc = new hypercube_float(fin.get_axes(), true);
    fin.read_all("in",trc);
    std::vector<axis> uaxes;
    uaxes.push_back(trc->get_axis(1)); uaxes.push_back(trc->get_axis(2));
    uaxes.push_back(trc->get_axis(3)); uaxes.push_back(trc->get_axis(4));
    hypercube_float *wfd = new hypercube_float(uaxes, true);
    igrad3 ig3 = igrad3(wfd->get_axes());
    ig3.forward(false,wfd,trc);
    sregf fout = sregf(wfd->get_axes());
    fout.write_description("out");
    fout.write_all("out",wfd);
    delete trc; delete wfd;
  } else {
    /* Build hypercubes */
    hypercube_float *wfd = new hypercube_float(fin.get_axes(), true);
    fin.read_all("in",wfd);
    std::vector<axis> traxes;
    traxes = wfd->get_axes();
    traxes.push_back(axis(3,0.0,1.0));
    hypercube_float *trc = new hypercube_float(traxes,true);
    igrad3 ig3 = igrad3(wfd->get_axes());
    ig3.forward(false,wfd,trc);
    sregf fout = sregf(trc->get_axes());
    fout.write_description("out");
    fout.write_all("out",trc);
    delete trc; delete wfd;
  }
}
