/*
 * lininterp-test.cpp
 *
 *  Created on: Nov 5, 2016
 *      Author: joe
 */

#include "../main/lininterp.h"
#include "../main/simpleplot.h"
#include "sep_params.h"

int main(int argc, char **argv) {

  sep_params pars = sep_params(argc, argv);

  sregf in = sregf("in");
  hypercube_float *srcin = new hypercube_float(in.get_axes(), true);
  in.read_all("in",srcin);

  int adj     = pars.get_int("adj",0);
  int ntout   = pars.get_int("nt"  , srcin->get_axis(1).n);
  float otout = pars.get_float("ot", srcin->get_axis(1).o);
  float dtout = pars.get_float("dt", srcin->get_axis(1).d);

  axis atout = axis(ntout, otout, dtout);
  std::vector<axis> axes(1); axes[0] = atout;

  hypercube_float *srcout = new hypercube_float(axes, true);

  lininterp li = lininterp(1);

  if(adj) {
    //simpleplot::plot1dimp(srcin);
    li.adjoint(false, srcout, srcin);
    //simpleplot::plot1dimp(srcout);
  } else {
    //simpleplot::plot1dimp(srcin);
    li.forward(false, srcin, srcout);
    //simpleplot::plot1dimp(srcout);
  }

  sregf out = sregf(axes);
  out.write_description("out");
  out.write_all("out",srcout);

  delete srcin;
  delete srcout;

  return 0;
}
