/**
 * A simple main program to test
 * the second derivative operator
 * @author: Joseph Jennings
 * @version: 2016.12.28
 */

#include "sep_params.h"
#include "sregf.h"
#include "hypercube_float.h"
#include "../main/scndder.h"

int main(int argc, char **argv) {

  sep_params pars = sep_params(argc, argv);

  int adj = pars.get_int("adj",0);

  sregf fin = sregf("in");

  hypercube_float *mod = new hypercube_float(fin.get_axes(),true);
  hypercube_float *dat = new hypercube_float(fin.get_axes(),true);

  scndder sdr = scndder(mod->get_axis(3));

  if(adj) {
    fin.read_all("in",dat);
    sdr.adjoint(false,mod,dat);
    sregf fout = sregf(mod->get_axes());
    fout.write_description("out");
    fout.write_all("out",mod);
  } else {
    fin.read_all("in",mod);
    sdr.forward(false,mod,dat);
    sregf fout = sregf(dat->get_axes());
    fout.write_description("out");
    fout.write_all("out",dat);
  }

  delete mod; delete dat;
}
