/**
 * A simple program to test
 * the cosine taper for absorbing
 * boundary wave propagation
 * @author: Joseph Jennings
 * @version: 2017.01.04
 */

#include "../main/tapercos.h"
#include "../main/simpleplot.h"
#include "sep_params.h"
#include "sregf.h"
#include "hypercube_float.h"

int main(int argc, char **argv) {

  sep_params pars = sep_params(argc, argv);

  int bx = pars.get_int("bx",50);
  int bz = pars.get_int("bz",50);
  int ord = pars.get_int("ord",10);
  float alpha = pars.get_float("alfa",0.97);

  sregf fin = sregf("in");

  tapercos tap = tapercos(fin.get_axes(), bz, bx, ord, alpha);

  hypercube_float *dat = new hypercube_float(fin.get_axes(), true);
  hypercube_float *zro = new hypercube_float(fin.get_axes(), true);

  fin.read_all("in", dat);

  //simpleplot::plot2d(dat);
  tap.apply(dat,zro);
  //simpleplot::plot2d(dat);

  hypercube_float *w = tap.get_taper();

  //simpleplot::plot2d(w);
  dat->scale_add(1.0,w,-1.0);
  //simpleplot::plot2d(dat);

  fin.write_description("tap");
  fin.write_all("tap",w);
  fin.write_description("out");
  fin.write_all("out",dat);

  delete dat;

}
